#property copyright "Copyright 2008, Ralph Ronnquist"

extern int magic = 9578;
extern int SL = 50;
extern int TP = 50;
extern double lots = 0.1;

#include <pipscharttrader.mqh>

//************************************************************
// MT4 API: Initialise the EA
int init()
{
    PipsChartInit();
    return(0);
}

// MT4 API: Terminate the EA
int deinit()
{
    return(0);
}

// MT4 API: On tick
int start()
{
    int entry = pcCheck();
    enterTrade( entry, lots, SL, TP );
    return( 0 );
}

//************************************************************
// Trade entry
void enterTrade(int cmd,double lots,int SL,int TP)
{
    static color colors[] = { Blue, Red };
    double price;
    double take;
    double stop;
    for ( ;; ) {
        if ( cmd == OP_BUY ) {
            price = Ask;
            take = Ask + TP * Point;
            stop = Ask - SL * Point;
        } else if ( cmd == OP_SELL ) {
            price = Bid;
            take = Bid - TP * Point;
            stop = Bid + SL * Point;
        } else {
           return;
        }
        int ticket = OrderSend(
            Symbol(), cmd, lots, price, 0, stop, take, "", magic, 0, colors[ cmd ] );
        if ( ticket >= 0 )
            break;
        // Maybe deal with some errors
        if ( fatal( GetLastError() ) )
            break;
        Sleep( 2000 );
        RefreshRates();
    }
}

#include <stderror.mqh>

bool fatal(int error)
{
    static int requotes[] = {
        ERR_TRADE_TIMEOUT,
        ERR_PRICE_CHANGED,
        ERR_OFF_QUOTES,
        ERR_BROKER_BUSY,
        ERR_REQUOTE,
        ERR_TRADE_CONTEXT_BUSY
    };
    for ( int i = ArraySize( requotes ) - 1; i >= 0; i-- ) {
        if ( error == requotes[ i ] )
            return( false );
    }
    return( true );
}

